#
# spec file for package rubygem-parser
#
# Copyright (c) 2024 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


#
# This file was generated with a gem2rpm.yml and not just plain gem2rpm.
# All sections marked as MANUAL, license headers, summaries and descriptions
# can be maintained in that file. Please consult this file before editing any
# of those fields
#

Name:           rubygem-parser
Version:        3.3.3.0
Release:        1.1
%define mod_name parser
%define mod_full_name %{mod_name}-%{version}
BuildRequires:  %{ruby >= 2.0.0}
BuildRequires:  %{rubygem gem2rpm}
BuildRequires:  ruby-macros >= 5
BuildRequires:  update-alternatives
URL:            https://github.com/whitequark/parser
Source:         https://rubygems.org/gems/%{mod_full_name}.gem
Source1:        gem2rpm.yml
Summary:        A Ruby parser written in pure Ruby
License:        MIT
PreReq:         update-alternatives

%description
A Ruby parser written in pure Ruby.

%prep

%build

%install
%gem_install \
  --symlink-binaries \
  --doc-files="LICENSE.txt" \
  -f
# MANUAL
for dir in $(ls %{buildroot}%{_libdir}/ruby/gems/); do
     %fdupes %{buildroot}%{_libdir}/ruby/gems/$dir
done
# /MANUAL

%gem_packages

%changelog
* Fri Jun 21 2024 Dan Čermák <dan.cermak@posteo.net>
- New upstream release 3.3.3.0, no changelog found
* Fri Jan 26 2024 Mykola Krachkovsky <w01dnick@gmail.com>
- updated to version 3.3.0.5
  v3.3.0.5 (2024-01-21)
  - --------------------
  API modifications:
  * Bump 3.2 branch to 3.2.3 (#993) (Koichi ITO)
  v3.3.0.4 (2024-01-15)
  - --------------------
  Features implemented:
  * Register a Ruby 3.4 parser (#991) (Jean byroot Boussier)
  v3.3.0.3 (2024-01-12)
  - --------------------
  Bugs fixed:
  * lexer.rl: accept tabs before closing heredoc delimiter (#990) (Ilya Bylich)
  v3.3.0.2 (2024-01-07)
  - --------------------
  Bugs fixed:
  * Fix an error when using heredoc with non-word delimiters (#987) (Koichi ITO)
  v3.3.0.1 (2024-01-06)
  - --------------------
  Bugs fixed:
  * Supports Ruby 2.0+ runtime (#986) (Koichi ITO)
  v3.3.0.0 (2024-01-05)
  - --------------------
  API modifications:
  * current.rb: mark 3.3 branch as stable (#984) (Ilya Bylich)
  * ruby33.y: extract string_dend (#969) (Ilya Bylich)
  * lexer.rl: treat numparams as locals (#968) (Ilya Bylich)
  * ruby33.y: extract words_sep (#967) (Ilya Bylich)
  * literal.rb: match heredoc identifier from end of line (#965) (Ilya Bylich)
  * ruby33.y: extract {endless_command,endless_arg} rules (#964) (Ilya Bylich)
  * Bump Racc to 1.7.3 (#954) (Koichi ITO)
  Features implemented:
  * ruby33.y: reject ambiguous anonymous arguments (#983) (Ilya Bylich)
  * ruby33.y: extract arg_splat rule. (#981) (Ilya Bylich)
  * builder.rb: warn `it` in a block with no ordinary params. (#980) (Ilya Bylich)
  * builder.rb: extract named captures only from static regexes. (#979) (Ilya Bylich)
  * ruby33.y: accept expr_value in sclass definition. (#978) (Ilya Bylich)
  * ruby33.y: extract p_in_kwarg (#977) (Ilya Bylich)
  * ruby33.y: extract p_assoc and p_in rules (#976) (Ilya Bylich)
  * ruby33.y: reject invalid gvar as symbol (#974) (Ilya Bylich)
  * ruby33.y: properly restore in_defined flag, extract begin_defined rule (#973) (Ilya Bylich)
  * builder.rb: reject multi-char gvar names starting with 0 (#972) (Ilya Bylich)
  * ruby33.y: allow semicolon in parenthesis at the first argument of command call (#971) (Ilya Bylich)
  * ruby33.y: parse qualified const with brace block as a method call (#970) (Ilya Bylich)
* Wed Oct 11 2023 Mykola Krachkovsky <w01dnick@gmail.com>
- updated to version 3.2.2.4
  v3.2.2.4 (2023-10-04)
  - --------------------
  API modifications:
  * bump Racc to 1.7.1 (#930) (Koichi ITO)
  Bugs fixed:
  * Fix an error for flip-flop with beginless or endless ranges (#946) (Koichi ITO)
* Sat Sep  2 2023 Mykola Krachkovsky <w01dnick@gmail.com>
- updated to version 3.2.2.3
  v3.2.2.3 (2023-06-08)
  - --------------------
  API modifications:
  * Add Racc to runtime dependencies (#929) (Koichi ITO)
  v3.2.2.2 (2023-06-08)
  - --------------------
  API modifications:
  * bump racc to 1.7.0 (#928) (Ilya Bylich)
  v3.2.2.0 (2023-04-01)
  - --------------------
  API modifications:
  * Bump maintenance branches to 3.2.2, 3.1.4, 3.0.6, and 2.7.8 (#920) (Koichi ITO)
  v3.2.1.1 (2023-03-08)
  - --------------------
  API modifications:
  * bump racc to 1.6.2 (#916) (Ilya Bylich)
  * backport tests for mixed usage of anonymous kwarg/kwrestarg and forwarded-arguments (#915) (Ilya Bylich)
  * add tests for kwopt+kwrest arguments and forwarded_kwrestarg. (#913) (Ilya Bylich)
  Bugs fixed:
  * builders/default: allow forwarded_kwrestarg with additional kwargs (#912) (Owen Stephens)
  v3.2.1.0 (2023-02-09)
  - --------------------
  API modifications:
  * Bump maintenance branches to 3.2.1 (#908) (Koichi ITO)
  * lexer.rl: extract strings lexing to lexer-strings.rl (#905) (Ilya Bylich)
  Features implemented:
  * Ruby 3.3 support (#904) (Ole Friis Østergaard)
  v3.2.0.0 (2023-01-03)
  - --------------------
  API modifications:
  * lexer.rl: extract `extend_string_escaped` to a separate method (#893) (Ilya Bylich)
  * bump Racc to 1.6.1 (#890) (Koichi ITO)
  Features implemented:
  * lexer.rl: use Ragel -F0 on non-CRuby (#894) (Benoit Daloze)
  * ruby32.y: Allow optional newlines before closing parenthesis (#892) (Koichi ITO)
  Bugs fixed:
  * ruby32.y: fix a parse error when using forwarded argument with restarg (#889) (Koichi ITO)
* Wed Dec  7 2022 Stephan Kulow <coolo@suse.com>
  updated to version 3.1.3.0
  no changelog found
* Fri Aug 26 2022 Manuel Schnitzer <mschnitzer@suse.com>
- updated to version 3.1.2.1
  Bugs fixed:
  * ruby31.y: fix preparing the state for one-line patterns without braces (#864) (Vladimir Dementyev)
* Thu Apr 28 2022 Stephan Kulow <coolo@suse.com>
  updated to version 3.1.2.0
  no changelog found
* Thu Mar  3 2022 Stephan Kulow <coolo@suse.com>
  updated to version 3.1.1.0
  no changelog found
* Tue Jan 25 2022 Stephan Kulow <coolo@suse.com>
  updated to version 3.1.0.0
  no changelog found
* Sat Dec 25 2021 Manuel Schnitzer <mschnitzer@suse.com>
- updated to version 3.0.3.2
  v3.0.3.2 (2021-12-08)
  - --------------------
  Bugs fixed:
  * dedenter.rb: fix an encoding/squiggly heredoc regression (#836) (hmdne)
  v3.0.3.1 (2021-11-29)
  - --------------------
  Features implemented:
  * ruby31.y: parse anonymous block argument. (#833) (Ilya Bylich)
  * ruby31.y: parse forward argument without parentheses (#832) (Ilya Bylich)
  v3.0.3.0 (2021-11-25)
  - --------------------
  API modifications:
  * Bump maintenance branches to 3.0.3, 2.7.5, and 2.6.9 (#829) (Koichi ITO)
  Features implemented:
  * lexer.rl: parse meta-control-hex chars in regexes starting from 3.1 (#828) (Ilya Bylich)
  * builder.rb: warn on duplicate hash key literals. (#827) (Ilya Bylich)
  * ruby31.y: Allow value omission in Hash literals (#818) (Svyatoslav Kryukov)
  * ruby31.y: Allow omission of parentheses in one line pattern matching (#816) (Koichi ITO)
  * ruby31.y: Add pattern matching pin support for instance/class/global variables (#813) (Koichi ITO)
  Bugs fixed:
  * ruby31.y: handle local variables as hash labels with omitted values (#820) (Ilya Bylich)
  * lexer.rl: Fix handling of beginless ranges at start of line (#822) (Matijs van Zuijlen)
  * dedenter.rb: Fix squiggly heredoc line continuation handling (#819) (Matijs van Zuijlen)
  * lexer.rl: fix incompatible delimiters on percent literal (#808) (Masataka Pocke Kuwabara)
* Sun Jul 11 2021 Manuel Schnitzer <mschnitzer@suse.com>
- updated to version 3.0.2.0
  API modifications:
  * Bump maintenance branches to 3.0.2, 2.7.4, and 2.6.8 (#805) (Koichi ITO)
  Features implemented:
  * lexer.rl: reject `\u` after control/meta escape chars. (#807) (Ilya Bylich)
  * ruby31.y: allow "command" syntax in endless method definition (#801) (Koichi ITO)
* Fri May 14 2021 Manuel Schnitzer <mschnitzer@suse.com>
- updated to version 3.0.1.1
  Features implemented:
  * Add `associate_by_identity` as an alternate to `associate` (#798) (Marc-André Lafortune)
  * ruby31.y: pin operator with expression (#797) (Ilya Bylich)
  * ruby31.y: branch parser (#792) (Koichi ITO)
  Bugs fixed:
  * fix a false positive for endless method definition (#796) (Koichi ITO)
* Sun Apr 11 2021 Manuel Schnitzer <mschnitzer@suse.com>
- updated to version 3.0.1.0
  API modifications:
  * Bump maintenance branches to 3.0.1, 2.7.3, 2.6.7, and 2.5.9 (#791) (Koichi ITO)
  Features implemented:
  * `Source::TreeRewriter#inspect` [#728] (#788) (Marc-André Lafortune)
  * `Source::Buffer#inspect` [#728] (#787) (Marc-André Lafortune)
* Fri Jan 22 2021 Stephan Kulow <coolo@suse.com>
  updated to version 3.0.0.0
  v3.0.0.0 (2020-12-25)
  - --------------------
  API modifications:
  * current.rb: bump default branch to parser/ruby30. (#782) (Ilya Bylich)
  * do not emit truncated parts of squiggly heredoc (#774) (Ilya Bylich)
  * Optimize `SourceBuffer` line and column handling (#755) (Marc-André Lafortune)
  Features implemented:
  * ruby30.y: reintroduce `expr in pat` (#777) (Ilya Bylich)
  * builder: emit implicit hash passed to a method call as kwargs (#769) (Ilya Bylich)
  * lexer.rl: use more specific warning for ambiguous slash. (#768) (Ilya Bylich)
  * ruby30.y: allow endless method without arglist. (#765) (Ilya Bylich)
  * ruby30.y: use `=>` for one-line pattern matching. (#760) (Ilya Bylich)
  * ruby30.y: reject setters in all endless method defs. (#758) (Ilya Bylich)
  Bugs fixed:
  * lexer.rl: don't perform lookahead after tASSOC. (#764) (Ilya Bylich)
  v2.7.2.0 (2020-10-06)
  API modifications:
  * Bump 2.7 branch to 2.7.2 (#748) (Koichi ITO)
* Fri Sep 25 2020 Stephan Kulow <coolo@suse.com>
  updated to version 2.7.1.5
  see installed CHANGELOG.md
* Tue Sep  1 2020 Dan Čermák <dcermak@suse.com>
- New upstream release 2.7.1.4
  v2.7.1.4 (2020-06-19)
  - --------------------
  Features implemented:
  * ruby28.y: add find pattern. (#714) (Ilya Bylich)
  * lexer.rl: reject `->...` and `->(...)` with the same error. (#713) (Ilya Bylich)
  * ruby28.y: accept leading args before forward arg. (#712) (Ilya Bylich)
  * Added `emit_forward_arg` compatibility flag. (#710) (Ilya Bylich)
  * ruby28.y: include entire lambda expr in lambda rule. (#708) (Ilya Bylich)
  * ruby28.y: extracted excessed_comma rule. (#706) (Ilya Bylich)
  * Source::TreeRewriter: Improved merging and representations (#703) (Marc-André Lafortune)
  Bugs fixed:
  * ruby*.y: fixed context inside lambda args and module. (#709) (Ilya Bylich)
  v2.7.1.3 (2020-05-26)
  - --------------------
  API modifications:
  * fixed all warnings. tests are running in verbose mode now. (#685) (Ilya Bylich)
  Features implemented:
  * ruby-[parse, rewrite]: add legacy switches (#699) (Marc-André Lafortune)
  * Added Parser::Source::Range#to_range. (#697) (Ilya Bylich)
  * ruby28.y: support rescue modifier in endless method definition. (#696) (Ilya Bylich)
  * ruby28.y: unify kwrest and no-kwrest rules. (#694) (Ilya Bylich)
  * ruby28.y: add right hand assignment (#682) (Vladimir Dementyev)
  Bugs fixed:
  * fix Comment.associate for postfix conditions/loops (#688) (Marc-André Lafortune)
* Thu May  7 2020 Stephan Kulow <coolo@suse.com>
- updated to version 2.7.1.2
  see installed CHANGELOG.md
* Mon Feb 10 2020 Stephan Kulow <coolo@suse.com>
- updated to version 2.7.0.2
  see installed CHANGELOG.md
* Tue Jan  7 2020 Dan Čermák <dcermak@suse.com>
- New upstream release 2.7.0.1
  v2.7.0.1 (2019-12-30)
  Bugs fixed:
  * dedenter.rb: prevent `ArgumentError` when processing binary en… (#642) (Koichi ITO)
  v2.7.0.0 (2019-12-26)
  API modifications:
  * README.md: documented compatibility issue with EOF chars after… (#637) (Ilya Bylich)
  * ruby27.y: refactor logic around 'circular argument reference'(#628) (Ilya Bylich)
  Features implemented:
  * ruby27.y: added pattern matching (#574) (Ilya Bylich)
  * lexer.rl: parse embedded ivars/cvars starting with digit as str (#639) (Ilya Bylich)
  * lexer.rl: warn on `...` at EOL. (#636) (Ilya Bylich)
  * ruby27.y: removed opt_block_args_tail: tOROP rule. (#635) (Ilya Bylich)
  * ruby27.y: reverted method reference operator (added in #634) (Ilya Bylich)
  * ruby27.y: treat numparams as locals outside numblock. (#633) (Ilya Bylich)
  Bugs fixed:
  * dedenter.rb: fixed over-dedenting of squiggly heredocs (#641) (Ilya Bylich)
  * ruby27.y: added "arguments forwarding" (#625) (Ilya Bylich)
  * ruby27.y: reject circular argument reference. (#622) (Ilya Bylich)
  * ruby27.y: changed prefix of numparams to "_" (#620) (Ilya Bylich)
  v2.6.5.0 (2019-10-03)
  API modifications:
  * Bump ruby versions to 2.4.9, 2.5.7 and 2.6.5. (#619) (Ilya Bylich)
  Features implemented:
  * lexer.rl: changed max numparam to `@9` (#617) (Ilya Bylich)
  * lexer.rl: support comments before leading dot in 27 mode. (#613) (Ilya Bylich)
  Bugs fixed:
  * lexer.rl: emit tMETHREF as tDOT+tCOLON for rubies \< 27. (#614) (Ilya Bylich)
* Tue Sep 17 2019 Dan Čermák <dcermak@suse.com>
- Update to version 2.6.4.1
  Bugs fixed:
  * lexer.rl: fix parsing of 'm a + b do end' (#605) (Ilya Bylich)
* Tue Sep 10 2019 Dan Čermák <dcermak@suse.com>
- update to version 2.6.4.0
  API modifications:
  * Added specs for heredocs with mixed encoding. (#581) (Ilya Bylich)
  Features implemented:
  * ruby27.y: Revert "pipeline operator" (#601) (Koichi ITO)
  * ruby27.y: Fix parsing of mutiple assignment with rescue modifier (#600) (Koichi ITO)
  * ruby27.y: hoisted out f_rest_marg. (#594) (Ilya Bylich)
  * ruby27.y: added pipeline operator. (#592) (Ilya Bylich)
  * ruby27.y: reject safe navigator in LHS of mass-assignment. (#586) (Ilya Bylich)
  * lexer.rl: reject whitespaces in meta and control chars. (#585) (Ilya Bylich)
  * lexer.rl: Reject numparams as symbol literals. (#582) (Ilya Bylich)
  * ruby27.y: Added numbered parameters support. (#565) (Ilya Bylich)
  * lexer.rl: Reject \n and \r in heredoc identifiers starting from 2.7. (#575) (Ilya Bylich)
  Bugs fixed:
  * ruby-parse: print empty string when --emit-json and empty input are given. (#590) (Ilya Bylich)
  * AST_FORMAT: fixed documentation of the string with interpolation. (#589) (Ilya Bylich)
  * builder.rb, processor.rb: Changed format of the procarg0 node. (#587) (Ilya Bylich)
* Sun May  5 2019 Stephan Kulow <coolo@suse.com>
- updated to version 2.6.3.0
  see installed CHANGELOG.md
* Fri Mar 29 2019 Stephan Kulow <coolo@suse.com>
- updated to version 2.6.2.0
  see installed CHANGELOG.md
  Not released (2019-03-21)
  - ------------------------
  API modifications:
  * Bump ruby versions to 2.5.5 and 2.6.2. (#563) (Ilya Bylich)
  * Bump Ruby version to 2.6.1. (#554) (Ilya Bylich)
  Features implemented:
  * ruby27.y: dsym should be treated as string. (#560) (Ilya Bylich)
  * ruby27.y: Refactored symbol rules. (#557) (Ilya Bylich)
  * ruby27.y: Added method reference operator. (#556) (Ilya Bylich)
  * ruby27.y: branch parser. (#546) (Ilya Bylich)
* Sat Mar  2 2019 Stephan Kulow <coolo@suse.com>
- updated to version 2.6.0.0
  see installed CHANGELOG.md
* Thu Nov 22 2018 Stephan Kulow <coolo@suse.com>
- updated to version 2.5.3.0
  see installed CHANGELOG.md
* Thu Jul 12 2018 factory-auto@kulow.org
- updated to version 2.5.1.2
  see installed CHANGELOG.md
* Wed Jul 11 2018 factory-auto@kulow.org
- updated to version 2.5.1.2
  see installed CHANGELOG.md
  Bugs fixed:
  * lexer.rl: Partially revert 5ba072d and properly handle 'm = -> *args do end'. (Ilya Bylich)
  v2.5.1.1 (2018-07-10)
  - --------------------
* Tue Jul 10 2018 factory-auto@kulow.org
- updated to version 2.5.1.1
  see installed CHANGELOG.md
* Thu Apr 12 2018 factory-auto@kulow.org
- updated to version 2.5.1.0
  see installed CHANGELOG.md
  Not released (2018-04-12)
  - ------------------------
  API modifications:
  * Parser::Current: bump latest 2.2 branch to 2.2.10. (Ilya Bylich)
  Features implemented:
  * ruby26.y: Raise a syntax error on 'else' without 'rescue'. This commit tracks upstream commit ruby/ruby@140512d. (Ilya Bylich)
  Bugs fixed:
  * lexer.rl, Dedenter: Treat slash in heredocs as a line continuation. (Ilya Bylich)
  * lexer.rl: Fix parsing of `a ? b + '': nil`. (Ilya Bylich)
  * lexer.rl: Reject `m a: {} {}` and `m [] {}` since 25. (Ilya Bylich)
  * builders/default: allow class/module/dynamic constant definition in the method body if there's a sclass between them. (bug #490) (Ilya Bylich)
  * lexer.rl: Emit :!@ as :!, :~@ as :~. (Ilya Bylich)
  * parse{23,24,25}.y: use only CMDARG/COND _PUSH/POP for cmdarg/cond management. (bug #481) (Ilya Bylich)
  * lexer.rl: emit tSTRING_BEG and tSTRING_DBEG one by one to allow parser to properly manipulate cmdarg stack. (bug #480) (Ilya Bylich)
* Sun Mar 25 2018 factory-auto@kulow.org
- updated to version 2.5.0.5
  see installed CHANGELOG.md
* Tue Mar 20 2018 factory-auto@kulow.org
- updated to version 2.5.0.4
  see installed CHANGELOG.md
* Tue Mar  6 2018 factory-auto@kulow.org
- updated to version 2.5.0.3
  see installed CHANGELOG.md
  Not released (2018-03-06)
  - ------------------------
  Bugs fixed:
  * Accept `BEGIN` and `END` as correct method name (#463) (Masataka Pocke Kuwabara)
  * Parser::Source::Buffer: Fixed parsing of encoding comment when the file contains only shebang. (Ilya Bylich)
* Fri Feb 23 2018 factory-auto@kulow.org
- updated to version 2.5.0.2
  see installed CHANGELOG.md
  v2.5.0.2 (2018-02-22)
  - --------------------
  Bugs fixed:
  * ruby24.y, ruby25.y: Replicate cmdargs handling from MRI. (#453) (Ilya Bylich)
* Thu Feb 22 2018 factory-auto@kulow.org
- updated to version 2.5.0.1
  see installed CHANGELOG.md
* Wed Feb 21 2018 cbruckmayer@suse.com
- updated to version 2.5.0.1
  see installed CHANGELOG.md
* Sat Feb 17 2018 factory-auto@kulow.org
- updated to version 2.5.0.0
  see installed CHANGELOG.md
* Sun Dec  3 2017 coolo@suse.com
- updated to version 2.4.0.2
  see installed CHANGELOG.md
  Not released (2017-11-13)
  - ------------------------
  API modifications:
  * parser/current: update for 2.3.5 release. (whitequark)
  v2.4.0.1 (2017-11-13)
  - --------------------
  API modifications:
  * parser/current: update for 2.3.4 release. (whitequark)
  * parser/current: update for Ruby 2.1.10 and 2.2.7. (Koichi ITO)
  Features implemented:
  * Allow rescue/else/ensure inside do/end blocks. [Feature #12906] (Ilya Bylich)
  * ruby25.y: branch parser. (Ilya Bylich)
  Bugs fixed:
  * Source::Comment::Associator: skip -*- magic comments -*-. (Denis Defreyne)
  * lexer.rl: "- 5": allow whitespace after tUNARY_NUM. (whitequark)
  * *ruby*.y, Builders::Default: "+5": don't lose location of the "+". (whitequark)
  * ruby-rewrite: allow passing paths to --load. (whitequark)
  * builders/default: "def x; else; end": don't crash. (whitequark)
* Wed Feb  8 2017 coolo@suse.com
- updated to version 2.4.0.0
  see installed CHANGELOG.md
  v2.4.0.0 (2017-02-07)
  - --------------------
  API modifications:
  * parser/current: update for the 2.4 release. (whitequark)
  * rubymotion.y: "a&.b": implement safe navigation operator in RubyMotion. (Mark Villacampa)
  Bugs fixed:
  * lexer.rl: "a &. b": accept &. in EXPR_ARG also. (whitequark)
* Fri Dec  9 2016 coolo@suse.com
- updated to version 2.3.3.1
  see installed CHANGELOG.md
  v2.3.3.1 (2016-12-02)
  - --------------------
  API modifications:
  * parser/current: update 2.2 warning to 2.2.6 (Jordan Moncharmont)
  v2.3.3.0 (2016-11-28)
  - --------------------
  API modifications:
  * parser/current: update 2.3 branch to 2.3.3. (Philip Arndt)
  Bugs fixed:
  * ruby24.y: "a += b += raise :x": fix errors with chained op-assignments. (whitequark)
  * ruby24.y: "p p{p(p);p p}, tap do end": preserve cmdarg stack. (whitequark)
  * ruby24.y: "a b{c d}, :e do end": go to EXPR_ENDARG after literal. (whitequark)
* Sun Nov 20 2016 coolo@suse.com
- updated to version 2.3.2.0
  see installed CHANGELOG.md
  v2.3.2.0 (2016-11-20)
  - --------------------
  API modifications:
  * parser/current: update 2.3 branch to 2.3.2. (whitequark)
  * Introduce (procarg0) node for a single required block argument. (Ilya Bylich)
  Bugs fixed:
  * {macruby,ruby{19,20,21,22,23,24}}.y: "x::A += m x": treat as constant assignment. (whitequark)
  * ruby24.y: "x += raise y rescue nil": bind rescue tighter than tOP_ASGN. (whitequark)
  * ruby24.y: "x = raise y rescue nil": bind rescue tighter than =. (whitequark)
  * Builders::Default: "begin; else; 1; end": fix a crash. (whitequark)
* Sat Oct  8 2016 coolo@suse.com
- updated to version 2.3.1.4
  see installed CHANGELOG.md
  v2.3.1.4 (2016-09-19)
  - --------------------
* Sun Sep 18 2016 coolo@suse.com
- updated to version 2.3.1.3
  see installed CHANGELOG.md
  v2.3.1.3 (2016-09-17)
  - --------------------
  API modifications:
  * parser/current: latest 2.3 release is 2.3.2. (Chris Riddoch)
  Features implemented:
  * ruby24.y: "f (g rescue nil)": allow stmt after tLPAREN_ARG. (whitequark)
  Bugs fixed:
  * ruby{18,19,20,21,22,23,24}.y: parse trailing commas as mlhs for block args "a.b{ |c,| d }" (fixes #312) (John Backus)
  * Builders::Default: "begin; 1; else; 2; end": do not drop else. (whitequark)
  * Builders::Default: "a&.b &&= c": fix safe navigation in lhs of op-assignment. (Ilya Bylich)
  * AST::Processor: handle "csend" as "send". (#301) (Ilya Bylich)
  * Parser::AST::Processor: do not spuriously modify ASTs. (Ilya Bylich)
  * lexer.rl: "%%w b\": lex backslash-delimited words literals. (Masataka Kuwabara)
* Thu Jun  2 2016 coolo@suse.com
- updated to version 2.3.1.2
  see installed CHANGELOG.md
  v2.3.1.2 (2016-06-02)
  - --------------------
  API modifications:
  * parser/current: update 2.2 warning to 2.2.5 (#295) (Kohei Suzuki)
  Bugs fixed:
  * AST_FORMAT: Fix `kwarg` example (#294) (Magnus Holm)
  v2.3.1.1 (2016-06-01)
  - --------------------
  Bugs fixed:
  * ruby{^18}.y: "lambda{|;a|a}": treat shadowarg as local inside block. (Ilya Bylich)
  * Builders::Default: "foo&.bar{}": emit csend in block properly. (whitequark)
  * runner.rb: re-add --23 (cremno)
  * runner.rb: make --24 actually use the 2.4 parser (cremno)
* Wed Apr 27 2016 coolo@suse.com
- updated to version 2.3.1.0
  see installed CHANGELOG.md
  v2.3.1.0 (2016-04-27)
  - --------------------
  Features implemented:
  * Parser::Current: update for Ruby 2.3.1. (whitequark)
  * Builders::Default: allow masgn in conditional context on >=Ruby 2.4. (whitequark)
  * ruby24.y: branch parser. (whitequark)
  Bugs fixed:
  * lexer.rl: "def x y; y A::B, ''; end": reject X:: in EXPR_ENDFN (fixes #285). (whitequark)
* Wed Apr  6 2016 coolo@suse.com
- updated to version 2.3.0.7
  see installed CHANGELOG.md
  v2.3.0.7 (2016-03-25)
  - --------------------
  API modifications:
  * Source::Diagnostic: handle ranges pointing to newlines (#273). (whitequark)
  Features implemented:
  * Parser::Base#tokenize: allow recovery from syntax errors. (whitequark)
  * lexer.rl: "a=1; a b: 1": allow label after command clashing with local. (whitequark)
  * lexer.rl: "undef %%s(x)": emit %%s literals in expr_fname in 2.3 mode. (whitequark)
  Bugs fixed:
  * Builders::Default: reject non-UTF-8 compatible literals. (whitequark)
* Wed Mar  2 2016 coolo@suse.com
- updated to version 2.3.0.6
  see installed CHANGELOG.md
  v2.3.0.6 (2016-02-14)
  - --------------------
  Bugs fixed:
  * lexer.rl: fix EOF location (closes #273). (whitequark)
  v2.3.0.5 (2016-02-12)
  - --------------------
  Bugs fixed:
  * lexer.rl: "%%Q{\あ}": fix encoding of UTF-8 noop escapes. (whitequark)
* Wed Feb 10 2016 coolo@suse.com
- updated to version 2.3.0.4
  see installed CHANGELOG.md
  v2.3.0.4 (2016-02-09)
  - --------------------
* Sun Feb  7 2016 coolo@suse.com
- updated to version 2.3.0.3
  see installed CHANGELOG.md
  v2.3.0.3 (2016-02-06)
  - --------------------
  API modifications:
  * lexer.rl: "a?=b": lex via tCHARACTER (closes #255). (whitequark)
* Mon Jan 25 2016 coolo@suse.com
- updated to version 2.3.0.2
  see installed CHANGELOG.md
  v2.3.0.2 (2016-01-24)
  - --------------------
  Bugs fixed:
  * Add :csend to Parser::Meta::NODE_TYPES (Markus Schirp)
  * lexer/dedenter: "\<\<x
  y\n  z
  x": don't dedent after escaped newline. (whitequark)
  v2.3.0.2 (2016-01-16)
  - --------------------
  v2.3.0.1 (2016-01-14)
  - --------------------
  Features implemented:
  * ruby23.y: implement optional superclass (cremno)
* Fri Jan 15 2016 coolo@suse.com
- updated to version 2.3.0.1
  see installed CHANGELOG.md
  v2.3.0.0 (2016-01-14)
  - --------------------
  Features implemented:
  * parser/current: update for released 2.3. (whitequark)
  * parse.y: "\<\<~HEREDOC": implement dedenting heredocs (fixes #228). (whitequark)
  v2.3.0.pre.6 (2015-12-20)
  - ------------------------
  API modifications:
  * parser/current: update 2.2 warning to 2.2.4. (whitequark)
  * ruby{22,23}.y: "1 ? p do end : 0". (whitequark)
  * lexer.rl: "{%%'a':1}": %%-string cannot be a label. (whitequark)
  * parser/current: update 2.1 warning to 2.1.8. (whitequark)
  Features implemented:
  * ruby-parse: add --emit-ruby option. (whitequark)
  Bugs fixed:
  * lexer.rl: "f(a ? 'a':1)": disallow quoted label at expr_value. (whitequark)
  v2.3.0.pre.5 (2015-12-16)
  - ------------------------
  API modifications:
  * Source::Diagnostic: output ^^^^^ instead of ^~~~~ (like clang). (whitequark)
  v2.3.0.pre.4 (2015-11-26)
  - ------------------------
  Bugs fixed:
  * ruby23.y: add generated grammar to gemspec. (whitequark)
  v2.3.0.pre.3 (2015-11-25)
  - ------------------------
  API modifications:
  * builders/default: introduce a (lambda) node (fixes #212). (whitequark)
  * lexer.rl: do not override argument variable. (Keiji, Yoshimi)
  * lexer.rl: rename variable names from lit to current_literal. (Keiji, Yoshimi)
  * lexer.rl: use Regexp to match string. (Keiji, Yoshimi)
  * lib/parser/source/buffer: reduce respond_to?(:bsearch) (Keiji, Yoshimi)
  * lexer.rl: reduce String literal allocations (Keiji, Yoshimi)
  * lexer.rl: reduce respond_to?(:encode) method call on #advance (Keiji, Yoshimi)
  * lexer.rl: reduce Stirng.length method call on #advance (Keiji, Yoshimi)
  * lexer.rl: reduce .class method call on #advance (Keiji, Yoshimi)
  Features implemented:
  * lexer.rl, ruby23.y: "a&.b": implement "safe navigation operator" (fixes #209). (whitequark)
  * ruby23.y: fork grammar. (whitequark)
  Bugs fixed:
  * lexer.rl: never let EOF token location point past EOF. (whitequark)
* Fri Oct  9 2015 coolo@suse.com
- updated to version 2.2.3.0
  see installed CHANGELOG.md
  v2.2.3.0 (2015-10-08)
  - --------------------
  Bugs fixed:
  * lexer.rl: "-> a: {}": state after -> is ENDFN, not END (fixes #203). (whitequark)
  * ruby{21,22}.y: "p -> { :hello }, a: 1 do end": lexpop cmdarg. (whitequark)
* Wed Jul  1 2015 coolo@suse.com
- updated to version 2.2.2.6
  see installed CHANGELOG.md
  v2.2.2.6 (2015-06-30)
  - --------------------
  API modifications:
  * parser/current: link to README from syntax deviation warning. (whitequark)
  Bugs fixed:
  * lexer.rl: "[/()\1/, ?#]": fixes #198. (whitequark)
* Thu May 28 2015 coolo@suse.com
- updated to version 2.2.2.5
  see installed CHANGELOG.md
  v2.2.2.5 (2015-05-25)
  - --------------------
  API modifications:
  * Source::Comment::Associator: rework entirely; fixes #194 (Oleg Zubchenko)
  Features implemented:
  * Source::Map: add last_line, last_column delegation (Oleg Zubchenko)
  * Source::Range: add last_line, last_column methods (Oleg Zubchenko)
  Bugs fixed:
  * AST::Processor: add missing on_block_pass (fixes #196) (whitequark)
* Mon May 18 2015 coolo@suse.com
- updated to version 2.2.2.3
  see installed CHANGELOG.md
  v2.2.2.3 (2015-05-17)
  - --------------------
  API modifications:
  * lexer.rl: "a?? 1 : 0": squelch "invalid character syntax" warning. (whitequark)
  Bugs fixed:
  * Source::Map: do not include :node in to_hash. (whitequark)
* Wed Apr 29 2015 coolo@suse.com
- updated to version 2.2.2.2
  see installed CHANGELOG.md
* Sun Apr 19 2015 coolo@suse.com
- updated to version 2.2.2.1
* Thu Apr 16 2015 coolo@suse.com
- updated to version 2.2.2.0
* Sat Feb 14 2015 coolo@suse.com
- updated to version 2.2.0.3
* Tue Feb 10 2015 coolo@suse.com
- updated to version 2.2.0.2
* Mon Oct 13 2014 coolo@suse.com
- adapt to new rubygem packaging
* Thu Feb  6 2014 kkaempf@suse.com
- Initial version 2.1.4
